<?php
  function dd ($val): void {
    printf("<pre>");
    var_dump($val);
    printf("</pre>");
    die();
  }

  function stacktrace (bool $return = false): array {
    $st = debug_backtrace();
    if (!$return) {
      error_log(print_r($st, true));
      return [];
    }
    else {
      return $st;
    }
  }

  // 簡単に問題をデバッグする為、ファイルと行列は必須です
  function doom (string $mess, string $file, int $line) {
    if (0 === error_reporting()) {
      $mess;
      return;
    }
    throw new \ErrorException($mess, 0, E_ALL, $file, $line);
  }

  set_error_handler("doom");
?>
